diff --git a/contrib/pg_stat_statements/pg_stat_statements.c b/contrib/pg_stat_statements/pg_stat_statements.c
index 92315627916..b9140212501 100644
--- a/contrib/pg_stat_statements/pg_stat_statements.c
+++ b/contrib/pg_stat_statements/pg_stat_statements.c
@@ -493,399 +602,689 @@ _PG_init(void)
 	ProcessUtility_hook = pgss_ProcessUtility;
 }
 
-/*
- * shmem request callback: Request shared memory resources.
- *
- * This is called at postmaster startup.  Note that the shared memory isn't
- * allocated here yet, this merely register our needs.
- *
- * In EXEC_BACKEND mode, this is also called in each backend, to re-attach to
- * the shared memory area that was already initialized.
+/*--------------------------------------------------------------------------
+ * pgstat flush helpers: merge per-kind timing counters into shared memory
+ *--------------------------------------------------------------------------
  */
 static void
-pgss_shmem_request(void *arg)
+pgss_flush_kind(pgssCounters *shared, pgssCounters *pending, pgssStoreKind kind)
+{
+	int64		n_a,
+				n_b;
+	double		delta;
+
+	n_a = shared->calls[kind];
+	n_b = pending->calls[kind];
+
+	shared->calls[kind] += n_b;
+	shared->total_time[kind] += pending->total_time[kind];
+
+	if (n_a == 0)
+	{
+		shared->min_time[kind] = pending->min_time[kind];
+		shared->max_time[kind] = pending->max_time[kind];
+		shared->mean_time[kind] = pending->mean_time[kind];
+		shared->sum_var_time[kind] = pending->sum_var_time[kind];
+	}
+	else
+	{
+		if (pending->min_time[kind] < shared->min_time[kind])
+			shared->min_time[kind] = pending->min_time[kind];
+		if (pending->max_time[kind] > shared->max_time[kind])
+			shared->max_time[kind] = pending->max_time[kind];
+
+		/*
+		 * Chan's parallel variance algorithm: combine two sets of (count,
+		 * mean, sum_of_squared_deviations). See
+		 * <http://www.johndcook.com/blog/standard_deviation/>
+		 */
+		delta = pending->mean_time[kind] - shared->mean_time[kind];
+		shared->sum_var_time[kind] +=
+			pending->sum_var_time[kind] +
+			delta * delta * (double) n_a * (double) n_b / (double) (n_a + n_b);
+		shared->mean_time[kind] =
+			shared->total_time[kind] / shared->calls[kind];
+	}
+}
+
+static bool
+pgss_flush_pending_cb(PgStat_EntryRef *entry_ref, bool nowait)
 {
-	ShmemRequestHash(.name = "pg_stat_statements hash",
-					 .nelems = pgss_max,
-					 .hash_info.keysize = sizeof(pgssHashKey),
-					 .hash_info.entrysize = sizeof(pgssEntry),
-					 .hash_flags = HASH_ELEM | HASH_BLOBS,
-					 .ptr = &pgss_hash,
-		);
-	ShmemRequestStruct(.name = "pg_stat_statements",
-					   .size = sizeof(pgssSharedState),
-					   .ptr = (void **) &pgss,
-		);
+	PgStat_PgssPending *pending;
+	PgStatShared_Pgss *shared;
+
+	pending = (PgStat_PgssPending *) entry_ref->pending;
+	shared = (PgStatShared_Pgss *) entry_ref->shared_stats;
+
+	if (!pgstat_lock_entry(entry_ref, nowait))
+		return false;
+
+	shared->key = pending->key;
+
+	pgss_flush_kind(&shared->counters, &pending->counters, PGSS_EXEC);
+
+	if (pgss_track_planning && pending->counters.calls[PGSS_PLAN] > 0)
+		pgss_flush_kind(&shared->counters, &pending->counters, PGSS_PLAN);
+
+	shared->counters.rows += pending->counters.rows;
+	shared->counters.shared_blks_hit += pending->counters.shared_blks_hit;
+	shared->counters.shared_blks_read += pending->counters.shared_blks_read;
+	shared->counters.shared_blks_dirtied += pending->counters.shared_blks_dirtied;
+	shared->counters.shared_blks_written += pending->counters.shared_blks_written;
+	shared->counters.local_blks_hit += pending->counters.local_blks_hit;
+	shared->counters.local_blks_read += pending->counters.local_blks_read;
+	shared->counters.local_blks_dirtied += pending->counters.local_blks_dirtied;
+	shared->counters.local_blks_written += pending->counters.local_blks_written;
+	shared->counters.temp_blks_read += pending->counters.temp_blks_read;
+	shared->counters.temp_blks_written += pending->counters.temp_blks_written;
+	shared->counters.shared_blk_read_time += pending->counters.shared_blk_read_time;
+	shared->counters.shared_blk_write_time += pending->counters.shared_blk_write_time;
+	shared->counters.local_blk_read_time += pending->counters.local_blk_read_time;
+	shared->counters.local_blk_write_time += pending->counters.local_blk_write_time;
+	shared->counters.temp_blk_read_time += pending->counters.temp_blk_read_time;
+	shared->counters.temp_blk_write_time += pending->counters.temp_blk_write_time;
+	shared->counters.wal_records += pending->counters.wal_records;
+	shared->counters.wal_fpi += pending->counters.wal_fpi;
+	shared->counters.wal_bytes += pending->counters.wal_bytes;
+	shared->counters.wal_buffers_full += pending->counters.wal_buffers_full;
+	shared->counters.jit_functions += pending->counters.jit_functions;
+	shared->counters.jit_generation_time += pending->counters.jit_generation_time;
+	shared->counters.jit_inlining_count += pending->counters.jit_inlining_count;
+	shared->counters.jit_inlining_time += pending->counters.jit_inlining_time;
+	shared->counters.jit_optimization_count += pending->counters.jit_optimization_count;
+	shared->counters.jit_optimization_time += pending->counters.jit_optimization_time;
+	shared->counters.jit_emission_count += pending->counters.jit_emission_count;
+	shared->counters.jit_emission_time += pending->counters.jit_emission_time;
+	shared->counters.jit_deform_count += pending->counters.jit_deform_count;
+	shared->counters.jit_deform_time += pending->counters.jit_deform_time;
+	shared->counters.parallel_workers_to_launch += pending->counters.parallel_workers_to_launch;
+	shared->counters.parallel_workers_launched += pending->counters.parallel_workers_launched;
+	shared->counters.generic_plan_calls += pending->counters.generic_plan_calls;
+	shared->counters.custom_plan_calls += pending->counters.custom_plan_calls;
+
+	if (pending->last_access_updated)
+		pg_atomic_write_u64(&shared->last_access,
+							(uint64) GetCurrentStatementStartTimestamp());
+
+	pgstat_unlock_entry(entry_ref);
+
+	return true;
 }
 
 /*
- * shmem init callback: Initialize our shared memory data structures at
- * postmaster startup.
- *
- * Load any pre-existing statistics from file.  Also create and load the
- * query-texts file, which is expected to exist (even if empty) while the
- * module is enabled.
+ * Serialize entry metadata + query text alongside each pgstat entry.
+ * On restart, from_serialized_data reconstructs both.
  */
 static void
-pgss_shmem_init(void *arg)
+pgss_to_serialized_data(const PgStat_HashKey *key,
+						const PgStatShared_Common *header,
+						FILE *statfile)
 {
-	int			tranche_id;
-	FILE	   *file = NULL;
-	FILE	   *qfile = NULL;
-	uint32		header;
-	int32		num;
-	int32		pgver;
-	int32		i;
-	int			buffer_size;
-	char	   *buffer = NULL;
+	PgStatShared_Pgss *shpgss = (PgStatShared_Pgss *) header;
+	bool		found = pgss_save;
+	char	   *qtext = NULL;
+	int			qtext_len = 0;
 
-	/*
-	 * We already checked that we're loaded from shared_preload_libraries in
-	 * _PG_init(), so we should not get here after postmaster startup.
-	 */
-	Assert(!IsUnderPostmaster);
-
-	/*
-	 * Initialize the shmem area with no statistics.
-	 */
-	tranche_id = LWLockNewTrancheId("pg_stat_statements");
-	LWLockInitialize(&pgss->lock.lock, tranche_id);
-	pgss->cur_median_usage = ASSUMED_MEDIAN_INIT;
-	pgss->mean_query_len = ASSUMED_LENGTH_INIT;
-	SpinLockInit(&pgss->mutex);
-	pgss->extent = 0;
-	pgss->n_writers = 0;
-	pgss->gc_count = 0;
-	pgss->stats.dealloc = 0;
-	pgss->stats.stats_reset = GetCurrentTimestamp();
-
-	/* The hash table must've also been initialized by now */
-	Assert(pgss_hash != NULL);
+	pgstat_write_chunk_s(statfile, &found);
 
-	/*
-	 * Set up a shmem exit hook to dump the statistics to disk on postmaster
-	 * (or standalone backend) exit.
-	 */
-	on_shmem_exit(pgss_shmem_shutdown, (Datum) 0);
+	if (!pgss_save)
+		return;
 
-	/*
-	 * Load any pre-existing statistics from file.
-	 *
-	 * Note: we don't bother with locks here, because there should be no other
-	 * processes running when this code is reached.
-	 */
+	pgss_attach_shmem();
 
-	/* Unlink query text file possibly left over from crash */
-	unlink(PGSS_TEXT_FILE);
+	pgstat_write_chunk_s(statfile, &shpgss->encoding);
+	pgstat_write_chunk_s(statfile, &shpgss->stats_since);
+	pgstat_write_chunk_s(statfile, &shpgss->minmax_stats_since);
 
-	/* Allocate new query text temp file */
-	qfile = AllocateFile(PGSS_TEXT_FILE, PG_BINARY_W);
-	if (qfile == NULL)
-		goto write_error;
+	/* Write query text */
+	if (DsaPointerIsValid(shpgss->query_text) && shpgss->query_len >= 0)
+		qtext = dsa_get_address(pgss_qtext_dsa, shpgss->query_text);
 
-	/*
-	 * If we were told not to load old statistics, we're done.  (Note we do
-	 * not try to unlink any old dump file in this case.  This seems a bit
-	 * questionable but it's the historical behavior.)
-	 */
-	if (!pgss_save)
+	if (qtext)
 	{
-		FreeFile(qfile);
-		return;
+		qtext_len = shpgss->query_len;
+		pgstat_write_chunk_s(statfile, &qtext_len);
+		pgstat_write_chunk(statfile, qtext, qtext_len + 1);
 	}
-
-	/*
-	 * Attempt to load old statistics from the dump file.
-	 */
-	file = AllocateFile(PGSS_DUMP_FILE, PG_BINARY_R);
-	if (file == NULL)
+	else
 	{
-		if (errno != ENOENT)
-			goto read_error;
-		/* No existing persisted stats file, so we're done */
-		FreeFile(qfile);
-		return;
+		qtext_len = -1;
+		pgstat_write_chunk_s(statfile, &qtext_len);
 	}
+}
 
-	buffer_size = 2048;
-	buffer = (char *) palloc(buffer_size);
-
-	if (fread(&header, sizeof(uint32), 1, file) != 1 ||
-		fread(&pgver, sizeof(uint32), 1, file) != 1 ||
-		fread(&num, sizeof(int32), 1, file) != 1)
-		goto read_error;
+/*
+ * Deserialize auxiliary data: restore metadata fields and query text.
+ */
+static bool
+pgss_from_serialized_data(const PgStat_HashKey *key,
+						  PgStatShared_Common *header,
+						  FILE *statfile)
+{
+	PgStatShared_Pgss *shpgss = (PgStatShared_Pgss *) header;
+	bool		had_entry;
+	int			qtext_len;
 
-	if (header != PGSS_FILE_HEADER ||
-		pgver != PGSS_PG_MAJOR_VERSION)
-		goto data_error;
+	if (!pgstat_read_chunk_s(statfile, &had_entry))
+		return false;
 
-	for (i = 0; i < num; i++)
+	if (!had_entry)
 	{
-		pgssEntry	temp;
-		pgssEntry  *entry;
-		Size		query_offset;
+		pgstat_drop_entry(PGSTAT_KIND_PGSS, key->dboid, key->objid, false);
+		pg_atomic_sub_fetch_u64(&pgss_shared->live_entries, 1);
+		return true;
+	}
+
+	if (!pgstat_read_chunk_s(statfile, &shpgss->encoding))
+		return false;
+	if (!pgstat_read_chunk_s(statfile, &shpgss->stats_since))
+		return false;
+	if (!pgstat_read_chunk_s(statfile, &shpgss->minmax_stats_since))
+		return false;
+	if (!pgstat_read_chunk_s(statfile, &qtext_len))
+		return false;
 
-		if (fread(&temp, sizeof(pgssEntry), 1, file) != 1)
-			goto read_error;
+	pgss_attach_shmem();
 
-		/* Encoding is the only field we can easily sanity-check */
-		if (!PG_VALID_BE_ENCODING(temp.encoding))
-			goto data_error;
+	if (qtext_len >= 0)
+	{
+		char	   *qtext;
+		dsa_pointer dp;
 
-		/* Resize buffer as needed */
-		if (temp.query_len >= buffer_size)
+		qtext = palloc(qtext_len + 1);
+		if (!pgstat_read_chunk(statfile, qtext, qtext_len + 1))
 		{
-			buffer_size = Max(buffer_size * 2, temp.query_len + 1);
-			buffer = repalloc(buffer, buffer_size);
+			pfree(qtext);
+			return false;
 		}
 
-		if (fread(buffer, 1, temp.query_len + 1, file) != temp.query_len + 1)
-			goto read_error;
-
-		/* Should have a trailing null, but let's make sure */
-		buffer[temp.query_len] = '\0';
-
-		/* Skip loading "sticky" entries */
-		if (IS_STICKY(temp.counters))
-			continue;
+		dp = dsa_allocate_extended(pgss_qtext_dsa, qtext_len + 1, DSA_ALLOC_NO_OOM);
+		if (DsaPointerIsValid(dp))
+		{
+			memcpy(dsa_get_address(pgss_qtext_dsa, dp), qtext, qtext_len + 1);
+			shpgss->query_text = dp;
+			shpgss->query_len = qtext_len;
+		}
+		else
+		{
+			shpgss->query_text = InvalidDsaPointer;
+			shpgss->query_len = -1;
+		}
 
-		/* Store the query text */
-		query_offset = pgss->extent;
-		if (fwrite(buffer, 1, temp.query_len + 1, qfile) != temp.query_len + 1)
-			goto write_error;
-		pgss->extent += temp.query_len + 1;
-
-		/* make the hashtable entry (discards old entries if too many) */
-		entry = entry_alloc(&temp.key, query_offset, temp.query_len,
-							temp.encoding,
-							false);
-
-		/* copy in the actual stats */
-		entry->counters = temp.counters;
-		entry->stats_since = temp.stats_since;
-		entry->minmax_stats_since = temp.minmax_stats_since;
+		pfree(qtext);
+	}
+	else
+	{
+		shpgss->query_text = InvalidDsaPointer;
+		shpgss->query_len = -1;
 	}
 
-	/* Read global statistics for pg_stat_statements */
-	if (fread(&pgss->stats, sizeof(pgssGlobalStats), 1, file) != 1)
-		goto read_error;
+	return true;
+}
 
-	pfree(buffer);
-	FreeFile(file);
-	FreeFile(qfile);
 
-	/*
-	 * Remove the persisted stats file so it's not included in
-	 * backups/replication standbys, etc.  A new file will be written on next
-	 * shutdown.
-	 *
-	 * Note: it's okay if the PGSS_TEXT_FILE is included in a basebackup,
-	 * because we remove that file on startup; it acts inversely to
-	 * PGSS_DUMP_FILE, in that it is only supposed to be around when the
-	 * server is running, whereas PGSS_DUMP_FILE is only supposed to be around
-	 * when the server is not running.  Leaving the file creates no danger of
-	 * a newly restored database having a spurious record of execution costs,
-	 * which is what we're really concerned about here.
-	 */
-	unlink(PGSS_DUMP_FILE);
-
-	return;
-
-read_error:
-	ereport(LOG,
-			(errcode_for_file_access(),
-			 errmsg("could not read file \"%s\": %m",
-					PGSS_DUMP_FILE)));
-	goto fail;
-data_error:
-	ereport(LOG,
-			(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-			 errmsg("ignoring invalid data in file \"%s\"",
-					PGSS_DUMP_FILE)));
-	goto fail;
-write_error:
-	ereport(LOG,
-			(errcode_for_file_access(),
-			 errmsg("could not write file \"%s\": %m",
-					PGSS_TEXT_FILE)));
-fail:
-	if (buffer)
-		pfree(buffer);
-	if (file)
-		FreeFile(file);
-	if (qfile)
-		FreeFile(qfile);
-	/* If possible, throw away the bogus file; ignore any error */
-	unlink(PGSS_DUMP_FILE);
+/*
+ * Store query text in the DSA area and update the entry's text pointer.
+ * On allocation failure, sets query_text to InvalidDsaPointer.
+ */
+static void
+pgss_store_query_text(PgStatShared_Pgss *entry, const char *query, int query_len,
+					  int encoding)
+{
+	dsa_pointer dp;
 
-	/*
-	 * Don't unlink PGSS_TEXT_FILE here; it should always be around while the
-	 * server is running with pg_stat_statements enabled
-	 */
+	dp = dsa_allocate_extended(pgss_qtext_dsa, query_len + 1, DSA_ALLOC_NO_OOM);
+	if (DsaPointerIsValid(dp))
+	{
+		char	   *dst = dsa_get_address(pgss_qtext_dsa, dp);
+
+		memcpy(dst, query, query_len);
+		dst[query_len] = '\0';
+		entry->query_text = dp;
+		entry->query_len = query_len;
+		entry->encoding = encoding;
+	}
+	else
+	{
+		entry->query_text = InvalidDsaPointer;
+		entry->query_len = -1;
+		entry->encoding = encoding;
+	}
 }
 
-/*
- * shmem_shutdown hook: Dump statistics into file.
+/*--------------------------------------------------------------------------
+ * pgss_evict: Evict the least-recently-used entries.
  *
- * Note: we don't bother with acquiring lock, because there should be no
- * other processes running when this is called.
+ * Called with pgss_shared->lock held exclusively.  Scans all entries,
+ * sorts by last_access timestamp (oldest first), and drops the bottom 5%.
+ *--------------------------------------------------------------------------
  */
-static void
-pgss_shmem_shutdown(int code, Datum arg)
+typedef struct pgssEvictEntry
 {
-	FILE	   *file;
-	char	   *qbuffer = NULL;
-	Size		qbuffer_size = 0;
-	HASH_SEQ_STATUS hash_seq;
-	int32		num_entries;
-	pgssEntry  *entry;
-
-	/* Don't try to dump during a crash. */
-	if (code)
-		return;
+	Oid			dbid;
+	uint64		objid;
+	TimestampTz last_access;
+	dsa_pointer text_ptr;
+}			pgssEvictEntry;
 
-	/* Safety check ... shouldn't get here unless shmem is set up. */
-	if (!pgss || !pgss_hash)
-		return;
+static int
+pgss_evict_entry_cmp(const void *a, const void *b)
+{
+	TimestampTz ta = ((const pgssEvictEntry *) a)->last_access;
+	TimestampTz tb = ((const pgssEvictEntry *) b)->last_access;
 
-	/* Don't dump if told not to. */
-	if (!pgss_save)
-		return;
+	if (ta < tb)
+		return -1;
+	if (ta > tb)
+		return 1;
+	return 0;
+}
+
+static void
+pgss_evict(void)
+{
+	dshash_seq_status hstat;
+	PgStatShared_HashEntry *p;
+	pgssEvictEntry *entries;
+	int			nentries = 0;
+	int			live = (int) pg_atomic_read_u64(&pgss_shared->live_entries);
+	int			nevict;
+	int			not_freed = 0;
+	instr_time	start,
+				duration;
+
+	INSTR_TIME_SET_CURRENT(start);
+
+	entries = palloc(live * sizeof(pgssEvictEntry));
+
+	dshash_seq_init(&hstat, pgss_hash, false);
+	while ((p = dshash_seq_next(&hstat)) != NULL)
+	{
+		PgStatShared_Pgss *shared;
 
-	file = AllocateFile(PGSS_DUMP_FILE ".tmp", PG_BINARY_W);
-	if (file == NULL)
-		goto error;
+		if (p->dropped)
+			continue;
 
-	if (fwrite(&PGSS_FILE_HEADER, sizeof(uint32), 1, file) != 1)
-		goto error;
-	if (fwrite(&PGSS_PG_MAJOR_VERSION, sizeof(uint32), 1, file) != 1)
-		goto error;
-	num_entries = hash_get_num_entries(pgss_hash);
-	if (fwrite(&num_entries, sizeof(int32), 1, file) != 1)
-		goto error;
+		shared = (PgStatShared_Pgss *) dsa_get_address(pgStatLocal.dsa, p->body);
 
-	qbuffer = qtext_load_file(&qbuffer_size);
-	if (qbuffer == NULL)
-		goto error;
+		entries[nentries].dbid = p->key.dboid;
+		entries[nentries].objid = p->key.objid;
+		entries[nentries].last_access = (TimestampTz) pg_atomic_read_u64(&shared->last_access);
+		entries[nentries].text_ptr = shared->query_text;
+		nentries++;
+	}
+	dshash_seq_term(&hstat);
 
-	/*
-	 * When serializing to disk, we store query texts immediately after their
-	 * entry data.  Any orphaned query texts are thereby excluded.
-	 */
-	hash_seq_init(&hash_seq, pgss_hash);
-	while ((entry = hash_seq_search(&hash_seq)) != NULL)
+	if (nentries == 0)
 	{
-		int			len = entry->query_len;
-		char	   *qstr = qtext_fetch(entry->query_offset, len,
-									   qbuffer, qbuffer_size);
+		pfree(entries);
+		return;
+	}
+
+	qsort(entries, nentries, sizeof(pgssEvictEntry), pgss_evict_entry_cmp);
 
-		if (qstr == NULL)
-			continue;			/* Ignore any entries with bogus texts */
+	nevict = Max(nentries / PGSS_EVICT_RATIO, 1);
 
-		if (fwrite(entry, sizeof(pgssEntry), 1, file) != 1 ||
-			fwrite(qstr, 1, len + 1, file) != len + 1)
+	/* Don't evict entries accessed within the grace period */
+	for (int i = 0; i < nevict; i++)
+	{
+		if (!TimestampDifferenceExceeds(entries[i].last_access,
+										GetCurrentTimestamp(),
+										PGSS_EVICT_GRACE_MS))
 		{
-			/* note: we assume hash_seq_term won't change errno */
-			hash_seq_term(&hash_seq);
-			goto error;
+			nevict = i;
+			break;
 		}
 	}
 
-	/* Dump global statistics for pg_stat_statements */
-	if (fwrite(&pgss->stats, sizeof(pgssGlobalStats), 1, file) != 1)
-		goto error;
+	for (int i = 0; i < nevict; i++)
+	{
+		PgStat_EntryRef *victim_ref;
+		dsa_pointer text_ptr = InvalidDsaPointer;
+		bool		freed;
 
-	pfree(qbuffer);
-	qbuffer = NULL;
+		/*
+		 * Look up the entry to safely clear its query_text pointer under the
+		 * entry-level lock before freeing.  This prevents concurrent readers
+		 * from following a dangling DSA pointer.
+		 */
+		victim_ref = pgstat_get_entry_ref(PGSTAT_KIND_PGSS, entries[i].dbid,
+										  entries[i].objid, false, NULL);
+		if (victim_ref != NULL)
+		{
+			PgStatShared_Pgss *shared;
 
-	if (FreeFile(file))
-	{
-		file = NULL;
-		goto error;
+			shared = (PgStatShared_Pgss *) victim_ref->shared_stats;
+			pgstat_lock_entry(victim_ref, false);
+			text_ptr = shared->query_text;
+			shared->query_text = InvalidDsaPointer;
+			pgstat_unlock_entry(victim_ref);
+		}
+
+		freed = pgstat_drop_entry(PGSTAT_KIND_PGSS, entries[i].dbid,
+								  entries[i].objid, true);
+
+		if (DsaPointerIsValid(text_ptr))
+			dsa_free(pgss_qtext_dsa, text_ptr);
+
+		if (!freed)
+			not_freed++;
+		pg_atomic_sub_fetch_u64(&pgss_shared->live_entries, 1);
 	}
 
-	/*
-	 * Rename file into place, so we atomically replace any old one.
-	 */
-	(void) durable_rename(PGSS_DUMP_FILE ".tmp", PGSS_DUMP_FILE, LOG);
-
-	/* Unlink query-texts file; it's not needed while shutdown */
-	unlink(PGSS_TEXT_FILE);
-
-	return;
-
-error:
-	ereport(LOG,
-			(errcode_for_file_access(),
-			 errmsg("could not write file \"%s\": %m",
-					PGSS_DUMP_FILE ".tmp")));
-	if (qbuffer)
-		pfree(qbuffer);
-	if (file)
-		FreeFile(file);
-	unlink(PGSS_DUMP_FILE ".tmp");
-	unlink(PGSS_TEXT_FILE);
+	pg_atomic_fetch_add_u64(&pgss_shared->dealloc, 1);
+
+	if (not_freed > 0)
+		pgstat_request_entry_refs_gc();
+
+	pfree(entries);
+
+	INSTR_TIME_SET_CURRENT(duration);
+	INSTR_TIME_SUBTRACT(duration, start);
 }
 
 /*
- * Post-parse-analysis hook: mark query with a queryId
+ * pgss_maybe_evict: Run eviction if needed.  Returns true if creation
+ * can proceed, false if the caller should skip recording.
+ *
+ * Must be called with pgss_shared->lock held exclusively.
  */
-static void
-pgss_post_parse_analyze(ParseState *pstate, Query *query, const JumbleState *jstate)
+static bool
+pgss_maybe_evict(void)
 {
-	if (prev_post_parse_analyze_hook)
-		prev_post_parse_analyze_hook(pstate, query, jstate);
+	int64		live = (int64) pg_atomic_read_u64(&pgss_shared->live_entries);
 
-	/* Safety check... */
-	if (!pgss || !pgss_hash || !pgss_enabled(nesting_level))
-		return;
+	/* Safety valve: dshash overflow from pinned entries (see above) */
+	if (pgstat_get_entry_count(PGSTAT_KIND_PGSS) >= pgss_max * 2)
+	{
+		pg_atomic_fetch_add_u64(&pgss_shared->skipped_entries, 1);
+		return false;
+	}
 
-	/*
-	 * If it's EXECUTE, clear the queryId so that stats will accumulate for
-	 * the underlying PREPARE.  But don't do this if we're not tracking
-	 * utility statements, to avoid messing up another extension that might be
-	 * tracking them.
-	 */
-	if (query->utilityStmt)
+	if (live >= pgss_max)
 	{
-		if (pgss_track_utility && IsA(query->utilityStmt, ExecuteStmt))
+		TimestampTz now = GetCurrentStatementStartTimestamp();
+		TimestampTz last = (TimestampTz) pg_atomic_read_u64(&pgss_shared->last_eviction);
+
+		if (last == 0 || TimestampDifferenceExceeds(last, now,
+													PGSS_EVICT_INTERVAL_MS))
 		{
-			query->queryId = INT64CONST(0);
-			return;
+			pg_atomic_write_u64(&pgss_shared->last_eviction, (uint64) now);
+			pgss_evict();
+		}
+		else
+		{
+			pg_atomic_fetch_add_u64(&pgss_shared->skipped_entries, 1);
+			return false;
 		}
 	}
 
-	/*
-	 * If query jumbling were able to identify any ignorable constants, we
-	 * immediately create a hash table entry for the query, so that we can
-	 * record the normalized form of the query string.  If there were no such
-	 * constants, the normalized string would be the same as the query text
-	 * anyway, so there's no need for an early entry.
-	 */
-	if (jstate && jstate->clocations_count > 0)
-		pgss_store(pstate->p_sourcetext,
-				   query->queryId,
-				   query->stmt_location,
-				   query->stmt_len,
-				   PGSS_INVALID,
-				   0,
-				   0,
-				   NULL,
-				   NULL,
-				   NULL,
-				   jstate,
-				   0,
-				   0,
-				   PLAN_STMT_UNKNOWN);
+	return true;
 }
 
-/*
- * Planner hook: forward to regular planner, but measure planning time
- * if needed.
+/*--------------------------------------------------------------------------
+ * pgss_store: Record statistics for one statement execution.
+ *
+ * Lock-free lookup for existing entries.  If the entry is new, takes an
+ * exclusive lock to serialize creation, evicting if at capacity.
+ *--------------------------------------------------------------------------
  */
-static PlannedStmt *
-pgss_planner(Query *parse,
-			 const char *query_string,
+static void
+pgss_store(const char *query, int64 queryId,
+		   int query_location, int query_len,
+		   pgssStoreKind kind,
+		   double total_time, uint64 rows,
+		   const BufferUsage *bufusage,
+		   const WalUsage *walusage,
+		   const struct JitInstrumentation *jitusage,
+		   const JumbleState *jstate,
+		   int parallel_workers_to_launch,
+		   int parallel_workers_launched,
+		   PlannedStmtOrigin planOrigin)
+{
+	pgssHashKey key;
+
+	uint64		objid;
+	PgStat_EntryRef *entry_ref;
+	PgStat_PgssPending *pending;
+	PgStatShared_Pgss *shared;
+	char	   *norm_query = NULL;
+	int			encoding = GetDatabaseEncoding();
+	bool		created_entry = false;
+
+	Assert(query != NULL);
+
+	if (queryId == INT64CONST(0))
+		return;
+
+	memset(&key, 0, sizeof(pgssHashKey));
+	key.userid = GetUserId();
+	key.dbid = MyDatabaseId;
+	key.queryid = queryId;
+	key.toplevel = (nesting_level == 0);
+
+	pgss_attach_shmem();
+
+	objid = pgss_hash_key(&key);
+
+	/* Fast path: check if the entry already exists (lock-free lookup) */
+	entry_ref = pgstat_get_entry_ref(PGSTAT_KIND_PGSS, key.dbid, objid,
+									 false, NULL);
+
+	if (entry_ref == NULL)
+	{
+		/*
+		 * Entry doesn't exist.  Serialize creation under exclusive lock,
+		 * evicting if needed.
+		 */
+		LWLockAcquire(&pgss_shared->lock, LW_EXCLUSIVE);
+
+		if (!pgss_maybe_evict())
+		{
+			LWLockRelease(&pgss_shared->lock);
+			return;
+		}
+
+		entry_ref = pgstat_prep_pending_entry(PGSTAT_KIND_PGSS, key.dbid,
+											  objid, &created_entry);
+
+		LWLockRelease(&pgss_shared->lock);
+	}
+	else
+		entry_ref = pgstat_prep_pending_entry(PGSTAT_KIND_PGSS, key.dbid,
+											  objid, &created_entry);
+
+	shared = (PgStatShared_Pgss *) entry_ref->shared_stats;
+
+	/* New entry, or existing entry whose text was freed during eviction */
+	if (created_entry || !DsaPointerIsValid(shared->query_text))
+	{
+		pgstat_lock_entry(entry_ref, false);
+
+		if (created_entry)
+		{
+			pg_atomic_fetch_add_u64(&pgss_shared->live_entries, 1);
+			shared->key = key;
+			shared->stats_since = GetCurrentTimestamp();
+			pg_atomic_init_u32(&shared->usage, 1);
+			pg_atomic_init_u64(&shared->last_access,
+							   (uint64) GetCurrentStatementStartTimestamp());
+			shared->minmax_stats_since = shared->stats_since;
+			shared->encoding = encoding;
+		}
+
+		if (!DsaPointerIsValid(shared->query_text))
+		{
+			query = CleanQuerytext(query, &query_location, &query_len);
+			if (jstate && jstate->clocations_count > 0)
+				norm_query = generate_normalized_query(jstate, query,
+													   query_location,
+													   &query_len);
+
+			pgss_store_query_text(shared, norm_query ? norm_query : query,
+								  query_len, encoding);
+		}
+		pgstat_unlock_entry(entry_ref);
+	}
+
+	if (norm_query)
+		pfree(norm_query);
+
+	if (!jstate)
+	{
+		Assert(kind == PGSS_PLAN || kind == PGSS_EXEC);
+
+		pending = (PgStat_PgssPending *) entry_ref->pending;
+		pending->key = key;
+
+		pending->counters.calls[kind]++;
+		pending->last_access_updated = true;
+		pending->counters.total_time[kind] += total_time;
+
+		if (pending->counters.calls[kind] == 1)
+		{
+			pending->counters.min_time[kind] = total_time;
+			pending->counters.max_time[kind] = total_time;
+			pending->counters.mean_time[kind] = total_time;
+		}
+		else
+		{
+			/*
+			 * Welford's online algorithm for accumulating mean and sum of
+			 * squared deviations. See
+			 * <http://www.johndcook.com/blog/standard_deviation/>
+			 */
+			double		old_mean = pending->counters.mean_time[kind];
+
+			pending->counters.mean_time[kind] +=
+				(total_time - old_mean) / pending->counters.calls[kind];
+			pending->counters.sum_var_time[kind] +=
+				(total_time - old_mean) * (total_time - pending->counters.mean_time[kind]);
+
+			if (pending->counters.min_time[kind] > total_time)
+				pending->counters.min_time[kind] = total_time;
+			if (pending->counters.max_time[kind] < total_time)
+				pending->counters.max_time[kind] = total_time;
+		}
+
+		pending->counters.rows += rows;
+
+		if (bufusage)
+		{
+			pending->counters.shared_blks_hit += bufusage->shared_blks_hit;
+			pending->counters.shared_blks_read += bufusage->shared_blks_read;
+			pending->counters.shared_blks_dirtied += bufusage->shared_blks_dirtied;
+			pending->counters.shared_blks_written += bufusage->shared_blks_written;
+			pending->counters.local_blks_hit += bufusage->local_blks_hit;
+			pending->counters.local_blks_read += bufusage->local_blks_read;
+			pending->counters.local_blks_dirtied += bufusage->local_blks_dirtied;
+			pending->counters.local_blks_written += bufusage->local_blks_written;
+			pending->counters.temp_blks_read += bufusage->temp_blks_read;
+			pending->counters.temp_blks_written += bufusage->temp_blks_written;
+			pending->counters.shared_blk_read_time += INSTR_TIME_GET_MILLISEC(bufusage->shared_blk_read_time);
+			pending->counters.shared_blk_write_time += INSTR_TIME_GET_MILLISEC(bufusage->shared_blk_write_time);
+			pending->counters.local_blk_read_time += INSTR_TIME_GET_MILLISEC(bufusage->local_blk_read_time);
+			pending->counters.local_blk_write_time += INSTR_TIME_GET_MILLISEC(bufusage->local_blk_write_time);
+			pending->counters.temp_blk_read_time += INSTR_TIME_GET_MILLISEC(bufusage->temp_blk_read_time);
+			pending->counters.temp_blk_write_time += INSTR_TIME_GET_MILLISEC(bufusage->temp_blk_write_time);
+		}
+
+		if (walusage)
+		{
+			pending->counters.wal_records += walusage->wal_records;
+			pending->counters.wal_fpi += walusage->wal_fpi;
+			pending->counters.wal_bytes += walusage->wal_bytes;
+			pending->counters.wal_buffers_full += walusage->wal_buffers_full;
+		}
+
+		if (jitusage)
+		{
+			pending->counters.jit_functions += jitusage->created_functions;
+			pending->counters.jit_generation_time += INSTR_TIME_GET_MILLISEC(jitusage->generation_counter);
+
+			if (INSTR_TIME_GET_MILLISEC(jitusage->deform_counter))
+				pending->counters.jit_deform_count++;
+			pending->counters.jit_deform_time += INSTR_TIME_GET_MILLISEC(jitusage->deform_counter);
+
+			if (INSTR_TIME_GET_MILLISEC(jitusage->inlining_counter))
+				pending->counters.jit_inlining_count++;
+			pending->counters.jit_inlining_time += INSTR_TIME_GET_MILLISEC(jitusage->inlining_counter);
+
+			if (INSTR_TIME_GET_MILLISEC(jitusage->optimization_counter))
+				pending->counters.jit_optimization_count++;
+			pending->counters.jit_optimization_time += INSTR_TIME_GET_MILLISEC(jitusage->optimization_counter);
+
+			if (INSTR_TIME_GET_MILLISEC(jitusage->emission_counter))
+				pending->counters.jit_emission_count++;
+			pending->counters.jit_emission_time += INSTR_TIME_GET_MILLISEC(jitusage->emission_counter);
+		}
+
+		pending->counters.parallel_workers_to_launch += parallel_workers_to_launch;
+		pending->counters.parallel_workers_launched += parallel_workers_launched;
+
+		if (planOrigin == PLAN_STMT_CACHE_GENERIC)
+			pending->counters.generic_plan_calls++;
+		else if (planOrigin == PLAN_STMT_CACHE_CUSTOM)
+			pending->counters.custom_plan_calls++;
+	}
+
+}
+
+/*--------------------------------------------------------------------------
+ * Hook implementations
+ *--------------------------------------------------------------------------
+ */
+
+static void
+pgss_post_parse_analyze(ParseState *pstate, Query *query,
+						const JumbleState *jstate)
+{
+	if (prev_post_parse_analyze_hook)
+		prev_post_parse_analyze_hook(pstate, query, jstate);
+
+	if (!pgss_enabled(nesting_level))
+		return;
+
+	/*
+	 * Clear queryId for EXECUTE so stats accumulate under the PREPARE's
+	 * queryId instead.
+	 */
+	if (query->utilityStmt)
+	{
+		if (pgss_track_utility && IsA(query->utilityStmt, ExecuteStmt))
+		{
+			query->queryId = INT64CONST(0);
+			return;
+		}
+	}
+
+	/*
+	 * If query jumbling were able to identify any ignorable constants, we
+	 * immediately create a hash table entry for the query, so that we can
+	 * record the normalized form of the query string.  If there were no such
+	 * constants, the normalized string would be the same as the query text
+	 * anyway, so there's no need for an early entry.
+	 */
+	if (jstate && jstate->clocations_count > 0)
+		pgss_store(pstate->p_sourcetext,
+				   query->queryId,
+				   query->stmt_location,
+				   query->stmt_len,
+				   PGSS_INVALID,
+				   0,
+				   0,
+				   NULL,
+				   NULL,
+				   NULL,
+				   jstate,
+				   0,
+				   0,
+				   PLAN_STMT_UNKNOWN);
+}
+
+static PlannedStmt *
+pgss_planner(Query *parse,
+			 const char *query_string,
 			 int cursorOptions,
 			 ParamListInfo boundParams,
 			 ExplainState *es)
